"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.appendEvent = exports.appendEvents = exports.writeEvents = void 0;
var promises_1 = __importDefault(require("fs/promises"));
var path_1 = __importDefault(require("path"));
var header_1 = require("./header");
var log = require('@home-gallery/logger')('events.append');
var stringifyNdJson = function (value) { return JSON.stringify(value) + '\n'; };
var writeEvents = function (eventsFilename, events) { return __awaiter(void 0, void 0, void 0, function () {
    var t0, exists, data;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                t0 = Date.now();
                return [4 /*yield*/, promises_1.default.access(eventsFilename).then(function () { return true; }).catch(function () { return false; })];
            case 1:
                exists = _a.sent();
                if (!!exists) return [3 /*break*/, 3];
                return [4 /*yield*/, promises_1.default.mkdir(path_1.default.dirname(eventsFilename.toString()), { recursive: true })];
            case 2:
                _a.sent();
                _a.label = 3;
            case 3:
                data = stringifyNdJson((0, header_1.createHeader)()) + events.map(stringifyNdJson).join('');
                return [4 /*yield*/, promises_1.default.writeFile(eventsFilename, data)];
            case 4:
                _a.sent();
                log.debug(t0, "Wrote ".concat(events.length, " events to ").concat(eventsFilename));
                return [2 /*return*/];
        }
    });
}); };
exports.writeEvents = writeEvents;
var appendEvents = function (eventsFilename, events) { return __awaiter(void 0, void 0, void 0, function () {
    var t0, stat;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                t0 = Date.now();
                return [4 /*yield*/, promises_1.default.stat(eventsFilename).catch(function (err) { return err.code == 'ENOENT' ? false : Promise.reject(err); })];
            case 1:
                stat = _a.sent();
                if (!stat || (stat === null || stat === void 0 ? void 0 : stat.size) === 0) {
                    log.debug("Events file ".concat(eventsFilename, " is missing or empty. Write new file"));
                    return [2 /*return*/, (0, exports.writeEvents)(eventsFilename, events)];
                }
                return [4 /*yield*/, promises_1.default.appendFile(eventsFilename, events.map(stringifyNdJson).join(''))];
            case 2:
                _a.sent();
                log.debug(t0, "Append ".concat(events.length, " events to ").concat(eventsFilename));
                return [2 /*return*/];
        }
    });
}); };
exports.appendEvents = appendEvents;
var appendEvent = function (eventsFilename, event) { return (0, exports.appendEvents)(eventsFilename, [event]); };
exports.appendEvent = appendEvent;
