"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mergeEvents = void 0;
var promises_1 = __importDefault(require("fs/promises"));
var read_events_1 = require("./read-events");
var append_event_1 = require("./append-event");
var log = require('@home-gallery/logger')('events.merge');
var byDate = function (a, b) {
    if (a.date && b.date) {
        return a.date < b.date ? -1 : 1;
    }
    else if (a.date) {
        return 1;
    }
    else {
        return -1;
    }
};
var mergeEvents = function (eventsFilename, events) { return __awaiter(void 0, void 0, void 0, function () {
    var exists, fileEvents, ids, uniqNewEvents, merged;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!(events === null || events === void 0 ? void 0 : events.length)) {
                    log.debug("Given events are empty. Skip merge");
                    return [2 /*return*/];
                }
                return [4 /*yield*/, promises_1.default.access(eventsFilename).then(function () { return true; }).catch(function () { return false; })];
            case 1:
                exists = _a.sent();
                if (!!exists) return [3 /*break*/, 3];
                log.debug("Event file ".concat(eventsFilename, " does not exists, create new event file"));
                return [4 /*yield*/, (0, append_event_1.writeEvents)(eventsFilename, events)];
            case 2:
                _a.sent();
                return [2 /*return*/, events];
            case 3: return [4 /*yield*/, (0, read_events_1.readEvents)(eventsFilename)];
            case 4:
                fileEvents = _a.sent();
                ids = fileEvents.data.reduce(function (result, event) { result[event.id] = event; return result; }, {});
                uniqNewEvents = events.filter(function (event) { return !ids[event.id]; });
                if (!uniqNewEvents.length) {
                    log.info("No new events found. Skip merge");
                    return [2 /*return*/, uniqNewEvents];
                }
                merged = fileEvents.data.concat(uniqNewEvents).sort(byDate);
                return [4 /*yield*/, (0, append_event_1.writeEvents)(eventsFilename, merged)];
            case 5:
                _a.sent();
                return [2 /*return*/, uniqNewEvents.sort(byDate)];
        }
    });
}); };
exports.mergeEvents = mergeEvents;
