export declare const isWin: boolean;
/**
 * @export
 * @param {number} pid process id. Required.
 * @returns {Promise<boolean>} true if the given process id is in the local
 * process table. The PID may be paused or a zombie, though.
 */
export declare function pidExists(pid: number | null | undefined): Promise<boolean>;
/**
 * @export
 * @returns {Promise<number[]>} all the Process IDs in the process table.
 */
export declare function pids(): Promise<number[]>;
/**
 * Send a signal to the given process id.
 *
 * @export
 * @param {number} pid the process id. Required.
 * @param {boolean} [force=false] if true, and the current user has
 * permissions to send the signal, the pid will be forced to shut down.
 */
export declare function kill(pid: number | null | undefined, force?: boolean): void;
